
package polyj.lang;

public final class DoubleWrap extends Primitive {
  public static final Object Default = (Object) new DoubleWrap(0.0);
  public double value;
  
  public double Unwrap()
  { return value; }
  
  public DoubleWrap(double i)
  { value = i; }
  public DoubleWrap() {}

  public static Object Cast(Object o) {
    Primitive p = (Primitive) o;
    return (Object) new DoubleWrap(p.doubleValue());
  }

  public String toString()
  { return String.valueOf(value); }
  public int hashCode() {
    long v = Double.doubleToLongBits(value);
    return (int) (v^(v>>>32));
  }

  public long longValue()
  { return (long) value; }
  public double doubleValue()
  { return value; }

  public int compareTo(DoubleWrap d)
  { return value == d.value ? 0 : value > d.value ? 1 : -1; }
}
